89e7137c0fe57d6a05612d0d073679cde4a4e993
[working/Evergreen.git] / Open-ILS / src / extras / Makefile.install
1 # ---------------------------------------------------------------------
2 # Author: Bill Erickson <erickson@esilibrary.com>
3 # Author: Dan Scott <dscott@laurentian.ca>
4 #
5 # Makefile to install prerequisites for OpenSRF and Evergreen
6 #
7 # Currently supports Debian (squeeze), Ubuntu (lucid), and Fedora (15).
8 # Working towards support of CentOS 5 / RHEL 5.
9 # Installs Perl prereqs, libjs with Perl wrapper, libdbi, libdbi-drivers, and libyaz
10 #
11 # usage:
12 #       make -f Makefile.install debian-squeeze
13 #       - or -
14 #       make -f Makefile.install ubuntu-lucid
15 #       - or -
16 #       make -f Makefile.install fedora15
17 #       - or -
18 #       make -f Makefile.install centos
19 #       - or -
20 #       make -f Makefile.install rhel
21 #
22 # Notes:
23 #
24 #       This makefile has been tested much more with Debian, Ubuntu, and
25 #       Fedora than CentOS, or RHEL.
26 #
27 # ---------------------------------------------------------------------
28  
29 # Make any assumptions about the shell being used explicit
30 SHELL=/bin/bash 
31
32 LIBJS=js-1.7.0
33 LIBJS_PERL=JavaScript-SpiderMonkey-0.20
34 LIBJS_URL=http://ftp.mozilla.org/pub/mozilla.org/js/$(LIBJS).tar.gz
35 LIBJS_PERL_URL=http://mirror.datapipe.net/pub/CPAN/authors/id/T/TB/TBUSCH/$(LIBJS_PERL).tar.gz
36 # used for installing libjs lib and header files
37 JS_INSTALL_PREFIX=/usr/
38
39 # The libdbi sources can be fetched from sourceforge.net.  They are stored on
40 # the open-ils.org site now for ease of direct linking
41 LIBDBI=libdbi-0.8.3
42 LIBDBI_DRIVERS=libdbi-drivers-0.8.3
43 LIBDBI_HOST=http://open-ils.org/~denials/evergreen
44
45 # We need a recent version of Yaz
46 # Debian Lenny and Ubuntu 8.10 come with 3.0.34
47 YAZ=yaz-3.0.47
48 YAZ_HOST=http://ftp.indexdata.dk/pub/yaz
49
50 # Business::OnlinePayment is not packaged on CentOS/RHEL
51 PAY_ONLINE=Business-OnlinePayment-3.00_08.tar.gz
52 PAY_ONLINE_HOST=http://ftp.perl.org/pub/CPAN/authors/id/I/IV/IVAN/
53
54 APT_TOOL=aptitude -yq
55 APT_SAFE_TOOL=aptitude -P
56 APT_BACKPORT_TOOL=aptitude -t squeeze-backports -yq
57
58 # 64 or 32 bit os?
59 LBITS=$(shell getconf LONG_BIT)
60
61 # Fedora?
62 FEDORA=$(shell uname -r | grep "\.fc[0-9][0-9]\.")
63
64 # Fedora 64-bit?
65 FEDORA_64=$(shell uname -r | grep "\.fc[0-9][0-9]\.x86_64")
66
67 #RHEL/Centos PGSQL 
68 PGSQL_HOST=http://yum.pgsqlrpms.org/reporpms/8.4
69 PGSQL_CENTOS=pgdg-centos-8.4-2.noarch.rpm
70 PGSQL_REDHAT=pgdg-redhat-8.4-2.noarch.rpm       
71
72 # Debian dependencies
73 DEBS =  \
74         apache2-prefork-dev\
75         aspell\
76         aspell-en\
77         libbusiness-creditcard-perl\
78         libbusiness-onlinepayment-authorizenet-perl\
79         libbusiness-onlinepayment-perl\
80         libdatetime-format-builder-perl\
81         libdatetime-format-iso8601-perl\
82         libdatetime-format-mail-perl\
83         libdatetime-perl\
84         libdatetime-timezone-perl\
85         libdatetime-set-perl\
86         libdbd-pg-perl\
87         libemail-send-perl\
88         libemail-simple-perl\
89         libgd-graph3d-perl\
90         liblog-log4perl-perl\
91         libmarc-record-perl\
92         libncurses5-dev\
93         libnet-server-perl\
94         libnet-ssh2-perl\
95         libnspr4-dev\
96         libole-storage-lite-perl\
97         libparent-perl \
98         libpq-dev\
99         libreadline5-dev\
100         libspreadsheet-writeexcel-perl\
101         libssh2-1-dev\
102         libtext-aspell-perl\
103         libtext-csv-perl\
104         libuniversal-require-perl\
105         libnet-ip-perl\
106         libunix-syslog-perl
107
108 # Debian Lenny and Ubuntu Intrepid bundle recent versions of yaz
109 EXTRA_DEBS = \
110         libbusiness-isbn-perl\
111         libbusiness-isbn-data-perl\
112         libmarc-charset-perl \
113         libmarc-xml-perl \
114         libnet-z3950-zoom-perl \
115         libyaz-dev \
116         yaz
117
118 EXTRA_DEBS_SQUEEZE = \
119     libuuid-tiny-perl
120
121 # Ubuntu Hardy requires libencode-perl # to get a version of Encode
122 # > 2.12 - see bug 525069.
123 EXTRA_ENCODE = \
124         libencode-perl
125
126 CENTOS = \
127         aspell \
128         aspell-devel \
129         aspell-en \
130         gd-devel \
131         libssh2-devel \
132         openssl-devel \
133         perl-Business-CreditCard \
134         perl-Business-ISBN \
135         perl-Business-ISBN-Data \
136         perl-Business-OnlinePayment \
137         perl-Class-Data-Inheritable \
138         perl-DateTime-Format-Builder \
139         perl-DateTime-Format-Strptime \
140         perl-Ima-DBI \
141         perl-DBD-Pg \
142         perl-GD-Graph3d \
143         perl-IO-stringy \
144         perl-Spreadsheet-WriteExcel \
145         perl-Text-Aspell \
146         perl-Text-CSV
147
148 CENTOS_PERL = \
149         Encode \
150         DBIx::ContextualFetch \
151         Getopt::Long \
152         Net::SSH2 \
153         Net::XMPP \
154         Net::Z3950::ZOOM
155
156 FEDORA_RPMS = \
157         aspell \
158         aspell-en \
159         libdbi \
160         libdbi-dbd-pgsql \
161         libdbi-devel \
162         libssh2-devel \
163         libyaz \
164         libyaz-devel \
165         mod_ssl \
166         ncurses-devel \
167         ncurses-libs \
168         perl-parent \
169         perl-Business-CreditCard \
170         perl-Business-ISBN \
171         perl-Business-ISBN-Data \
172         perl-DBD-Pg \
173         perl-Email-Send \
174         perl-Email-Simple \
175         perl-GDGraph3d \
176         perl-Net-IP \
177         perl-Net-SSH2 \
178         perl-OLE-Storage_Lite \
179         perl-Spreadsheet-WriteExcel \
180         perl-Text-Aspell \
181         perl-Text-CSV \
182         perl-Text-CSV_XS \
183         perl-XML-Writer \
184         postgresql-devel \
185         readline-devel \
186         tcp_wrappers-devel \
187         wget \
188         yaz
189
190 # Note: B:O:AuthorizeNet 3.21 fails with https://rt.cpan.org/Public/Bug/Display.html?id=55172
191 # Should be fixed in 3.22
192 # MARC::Record 2.0.1 is required but only 2.0.0 is packaged
193 FEDORA_CPAN = \
194         Business::OnlinePayment \
195         Business::OnlinePayment::AuthorizeNet \
196         MARC::Record \
197         UUID::Tiny
198
199 PGSQL_90_RPMS = \
200         postgresql90 \
201         postgresql90-contrib \
202         postgresql90-devel \
203         postgresql90-libs \
204         postgresql90-plperl \
205         postgresql90-server
206
207 PGSQL_CLIENT_DEBS_90 = \
208         libpq5 \
209         libpq-dev \
210         postgresql-client-9.0
211
212 PGSQL_SERVER_DEBS_90 = \
213         postgresql-9.0 \
214         postgresql-contrib-9.0 \
215         postgresql-plperl-9.0 \
216         postgresql-server-dev-9.0
217
218 DEB_APACHE_MODS = \
219     expires\
220     include\
221     proxy\
222     proxy_http\
223     rewrite
224
225 DEB_APACHE_DISMODS = \
226     deflate
227
228 # Chronically unpackaged CPAN modules
229 CPAN_MODULES = \
230     Business::EDI \
231     Library::CallNumber::LC \
232     Net::Z3950::Simple2ZOOM \
233     SRU
234
235 # More chronically unpackaged CPAN modules (available in Squeeze though)
236 CPAN_MODULES_MORE = \
237     Business::CreditCard::Object \
238     MARC::Record \
239     Net::SSH2 \
240     UUID::Tiny
241
242 # Are we sure most distros don't come with an acceptable version of Safe.pm?
243 CPAN_MODULES_SAFE = \
244         Safe
245
246 # Recent Debian/Ubuntus have libmarc-charset-perl, libmarc-xml-perl, libnet-z3950-zoom-perl
247 CPAN_MODULES_MARC = \
248         Business::ISBN \
249         Business::ISBN::Data \
250         MARC::Charset \
251         MARC::File::XML \
252         Net::Z3950::ZOOM
253
254 CPAN_MODULES_MARC_RECORD = \
255         MARC::Record
256
257 CPAN_MODULES_FORCE = \
258         Class::DBI::Frozen::301
259
260 # Lucid needs this because the XML::RPC that comes by default is broken with Evergreen
261 LUCID_CPAN = \
262         XML::RPC
263
264 # ----------------------------------------------------------------------------
265
266 all: 
267         @echo "please specify an OS" && exit 0
268
269 # these should be the same for any distro
270 install: install_cpan install_js_sm install_libdbi install_cpan_force
271
272 centos: install_centos_pgsql centos_like
273 rhel: install_redhat_pgsql centos_like
274 centos_like: install_centos_rpms install_yaz install_cpan_marc install install_centos_perl create_ld_local install_cpan_safe install_cpan_force
275
276 fedora15: install_fedora_rpms install_cpan install_cpan_fedora install_cpan_marc install_js_sm install_cpan_force
277
278 debian-squeeze: squeeze generic_debian
279 squeeze: install_pgsql_client_debs_90  install_extra_debs_squeeze
280 generic_debian:  install_debs test_for_libdbi_pkg install debian_sys_config install_cpan_force
281
282 ubuntu-lucid: lucid generic_ubuntu
283 lucid: install_pgsql_client_debs_90 install_extra_debs install_cpan_marc_record install_yaz install_cpan_lucid
284 generic_ubuntu: install_debs test_for_libdbi_pkg install debian_sys_config install_cpan_more install_cpan_safe install_cpan_force
285
286 # - COMMON TARGETS ---------------------------------------------------------
287
288 # Install the CPAN modules
289 install_cpan: 
290         for m in $(CPAN_MODULES); do perl -MCPAN -e "install \"$$m\";"; done
291
292 install_cpan_more: 
293         for m in $(CPAN_MODULES_MORE); do perl -MCPAN -e "install \"$$m\";"; done
294
295 # Install the CPAN modules for MARC functionality
296 install_cpan_marc: install_cpan_marc_record
297         for m in $(CPAN_MODULES_MARC); do perl -MCPAN -e "install \"$$m\";"; done
298
299 install_cpan_marc_record:
300         for m in $(CPAN_MODULES_MARC_RECORD); do perl -MCPAN -e "install \"$$m\";"; done
301
302 install_cpan_force:
303         for m in $(CPAN_MODULES_FORCE); do \
304                 echo "force install $$m" | perl -MCPAN -e shell ;\
305         done
306
307 # Install the Safe Perl module
308 # Is this really unpackaged everywhere except for Fedora?
309 install_cpan_safe: 
310         for m in $(CPAN_MODULES_SAFE); do perl -MCPAN -e "install \"$$m\";"; done
311
312 # Install the CPAN modules for Fedora
313 install_cpan_fedora: 
314         for m in $(FEDORA_CPAN); do \
315                 echo "force install $$m" | perl -MCPAN -e shell;\
316         done
317
318 # Install the CPAN modules needed for Lucid
319 install_cpan_lucid:
320         for m in $(LUCID_CPAN); do perl -MCPAN -e "install \"$$m\";"; done
321
322 # Install a known working version of YAZ
323 install_yaz:    
324         if [ ! -d $(YAZ) ]; then wget $(YAZ_HOST)/$(YAZ).tar.gz; fi;
325         tar xzf $(YAZ).tar.gz
326         cd $(YAZ) && ./configure && make && make install && ldconfig
327
328 # Install the custom spidermonkey libs and JavaScript-SpiderMonkey Perl modules
329 install_js_sm: install_libjs install_spidermonkey
330
331 install_libjs: 
332         if [ ! -f $(LIBJS).tar.gz ]; then wget $(LIBJS_URL); fi;
333         tar -zxf $(LIBJS).tar.gz
334         cd js/src/ && JS_DIST=/usr make -f Makefile.ref
335         mkdir -p $(JS_INSTALL_PREFIX)/include/js/
336         cp js/src/*.h $(JS_INSTALL_PREFIX)/include/js/
337         cp js/src/*.tbl $(JS_INSTALL_PREFIX)/include/js/
338         if [ ! -z $(FEDORA_64) ]; then \
339                 cp js/src/Linux_All_DBG.OBJ/*.so $(JS_INSTALL_PREFIX)/lib64/ && \
340                 cp js/src/Linux_All_DBG.OBJ/*.a $(JS_INSTALL_PREFIX)/lib64/; \
341         else \
342                 cp js/src/Linux_All_DBG.OBJ/*.so $(JS_INSTALL_PREFIX)/lib/ && \
343                 cp js/src/Linux_All_DBG.OBJ/*.a $(JS_INSTALL_PREFIX)/lib/; \
344         fi;
345         ldconfig
346
347 install_spidermonkey:
348         if [ ! -f $(LIBJS_PERL).tar.gz ]; then wget $(LIBJS_PERL_URL); fi;
349         tar -zxf $(LIBJS_PERL).tar.gz
350         if [ ! -z $(FEDORA_64) ]; then \
351                 sed -i -e 's/"\/usr\/lib"/"\/usr\/lib64"/' $(LIBJS_PERL)/Makefile.PL ; \
352         fi;
353         if [ ! -z $(FEDORA) ]; then \
354                 sed -i -e 's/js32.dll/libjs.so/' $(LIBJS_PERL)/Makefile.PL ; \
355         fi;
356         cd $(LIBJS_PERL) && perl Makefile.PL -E4X && make && make test && make install
357
358 # On Ubuntu and possibly Debian, the libdbi0 package prevents the 
359 # compiled-from-source version from being used and breaks the install.
360 # This package might get installed depending on the install-time choices
361 # for the distro. Test for its existence; if it's there, throw an error
362 # message and exit.
363 test_for_libdbi_pkg:
364                 @if [ "$$(apt-cache policy libdbi0 | grep Installed | grep none | wc -l)" -eq 0 ]; then \
365                                 echo "*** Detected locally installed libdbi0 package; you must remove this"; \
366                                 echo "*** with a command like 'aptitude remove libdbi0' before proceeding"; \
367                                 echo "*** to successfully install Evergreen."; \
368                                 echo; \
369                                 echo "*** Note: this may break other applications on your system."; \
370                                 exit 0; \
371                 fi;
372
373 # Install libdbi and the postgres drivers
374 install_libdbi:
375         if [ ! -d $(LIBDBI) ]; then wget $(LIBDBI_HOST)/$(LIBDBI).tar.gz; fi;
376         if [ ! -d $(LIBDBI_DRIVERS) ]; then wget $(LIBDBI_HOST)/$(LIBDBI_DRIVERS).tar.gz; fi;
377         tar -zxf $(LIBDBI).tar.gz
378         tar -zxf $(LIBDBI_DRIVERS).tar.gz
379         cd $(LIBDBI) && ./configure --disable-docs && make all install
380         cd $(LIBDBI_DRIVERS) && ./configure  \
381                 --disable-docs --with-pgsql --enable-libdbi && make all install  
382
383 clean:
384         make -C $(LIBDBI) clean
385         make -C $(LIBDBI_DRIVERS) clean
386         make -C $(LIBJS_PERL) clean
387         make -f Makefile.ref -C js/src/ clean
388
389
390 # ------------------------------------------------------------------
391 # - DEBIAN ---------------------------------------------------------
392
393 debian_sys_config: 
394         # link the apache modules in
395         for m in $(DEB_APACHE_MODS); do a2enmod $$m; done;
396         # keep the bad apache modules away
397         for m in $(DEB_APACHE_DISMODS); do a2dismod $$m; done;
398         # refresh the dynamic library cache
399         ldconfig
400
401 # Install the debian-specific dependencies
402 install_debs:
403         $(APT_TOOL) install $(DEBS)
404
405 install_pgsql_client_debs_90:
406         @if [ `$(APT_TOOL) versions libpq-dev | grep ^i|sed 's/^i[ \t]*//'|cut -d. -f1` -eq 8 ]; \
407                 then \
408                 echo -e "libpq5 / libpq-dev are installed as part of OpenSRF (a dependency" \
409                 "of apache2-prefork-dev), but these are the 8.4 versions and they" \
410                 "conflict with the 9.0 versions - so remove them, install the pinned" \
411                 "backports of 9.0, then reinstall the apache2-prefork-dev package.\n\n" \
412                 "**WARNING**: Saying 'Yes' to this step will _remove_ any PostgreSQL" \
413                 "databases that might currently exist on this machine." && \
414                 $(APT_SAFE_TOOL) remove libpq5 libpq-dev ; \
415         fi
416         $(APT_BACKPORT_TOOL) install $(PGSQL_CLIENT_DEBS_90)
417         $(APT_TOOL) install apache2-prefork-dev
418
419 install_pgsql_server_debs_90:
420         $(APT_BACKPORT_TOOL) install $(PGSQL_SERVER_DEBS_90)
421
422 # Install the debian-specific dependencies for more modern distros
423 install_extra_debs_squeeze: install_extra_debs
424         $(APT_TOOL) install $(EXTRA_DEBS_SQUEEZE)
425
426 install_extra_debs:
427         $(APT_TOOL) install $(EXTRA_DEBS)
428
429 # Install specific modules required by Ubuntu Hardy - see bug 525069
430 install_extra_encode:
431         $(APT_TOOL) install $(EXTRA_ENCODE)
432
433 # ------------------------------------------------------------------
434
435 # FEDORA
436 install_fedora_rpms:
437         yum -y update
438         yum -y install $(FEDORA_RPMS)
439
440 install_fedora_pgsql_server:
441         yum -y install $(PGSQL_84_RPMS)
442
443 # CENTOS
444 install_centos_rpms:
445         yum -y install $(CENTOS)
446         yum -y update
447         if [ $(LBITS) -eq 64 ]; then \
448                 ln -sf /usr/lib64/libpq.* /usr/lib/ && \
449                 ln -sf /usr/lib64/perl5/5.8.8/x86_64-linux-thread-multi/CORE/libperl.so /usr/lib/ && \
450                 ldconfig ; \
451         fi;
452         if [ $(LBITS) -eq 32 ]; then \
453                 ln -sf /usr/lib/perl5/5.8.8/i386-linux-thread-multi/CORE/libperl.so /usr/lib && \
454                 ldconfig ; \
455         fi;
456
457 install_centos_pgsql:
458         if [ $(LBITS) -eq 64 ]; then yum remove -y postgresql-libs-8.1*i386 apr-util-devel-*i386 ; fi;
459         wget $(PGSQL_HOST)/$(PGSQL_CENTOS)
460         rpm -Uvh --force ./$(PGSQL_CENTOS)
461         yum update -y
462         yum -y install $(PGSQL_84_RPMS)
463
464 install_redhat_pgsql:
465         if [ $(LBITS) -eq 64 ]; then yum remove -y postgresql-libs-8.1*i386 apr-util-devel-*i386 ; fi;
466         wget $(PGSQL_HOST)/$(PGSQL_REDHAT)
467         rpm -Uvh --force ./$(PGSQL_REDHAT)
468         yum update -y
469         yum -y install $(PGSQL_84_RPMS)
470
471 install_centos_perl:
472         for m in $(CENTOS_PERL); do perl -MCPAN -e "install \"$$m\";"; done
473         echo "force install Business::OnlinePayment::AuthorizeNet" | perl -MCPAN -e shell
474         echo "force install Scalar::Util" | perl -MCPAN -e shell        
475
476 # We need to add /usr/local/lib to the ldconfig list of directories on CentOS,
477 # if it is not already there
478 create_ld_local:
479         if [ "$$(ldconfig -v 2> /dev/null | grep '^/usr/local/lib' | wc -l)" -eq 0 ]; then \
480                 echo '/usr/local/lib' >> /etc/ld.so.conf.d/local.conf; \
481                 ldconfig; \
482         fi;
483
484 # vim:noet:sw=4:ts=4: